| D++ (DPP) C++ Discord API Bot Library

Search
Loading...
Searching...
No Matches
dpp::detail::async::callback< R > Struct Template Reference

Shared state of the async and its callback, to be used across threads. More...

`#include <async.h>`

Collaboration diagram for dpp::detail::async::callback< R >:
[legend]

## Public Member Functions

void | operator() () const
| Call operator, sets the value in the promise and notifies any awaiter.
template<typename U = R> requires (std::convertible_to<const U&, R>)
void | operator() (const U &v) const
| Call operator, sets the value in the promise and notifies any awaiter.
template<typename U = R> requires (std::convertible_to<U&&, R>)
void | operator() (U &&v) const
| Call operator, sets the value in the promise and notifies any awaiter.

## Public Attributes

std::shared_ptr< basic_promise< R > > | promise {nullptr}
| Promise object to set the result into.

## Detailed Description

template<typename R>
struct dpp::detail::async::callback< R >

Shared state of the async and its callback, to be used across threads.

## Member Function Documentation

## ◆ operator()() [1/3]

template<typename R>

void dpp::detail::async::callback< R >::operator() | ( |  | ) | const

inline

Call operator, sets the value in the promise and notifies any awaiter.

## ◆ operator()() [2/3]

template<typename R>
template<typename U = R>
requires (std::convertible_to<const U&, R>)

void dpp::detail::async::callback< R >::operator() | ( | const U & | v | ) | const

inline

Call operator, sets the value in the promise and notifies any awaiter.

Parameters

  v | Callback value

## ◆ operator()() [3/3]

template<typename R>
template<typename U = R>
requires (std::convertible_to<U&&, R>)

void dpp::detail::async::callback< R >::operator() | ( | U && | v | ) | const

inline

Call operator, sets the value in the promise and notifies any awaiter.

Parameters

  v | Callback value

## Member Data Documentation

## ◆ promise

template<typename R>

std::shared_ptr<basic_promise<R> > dpp::detail::async::callback< R >::promise {nullptr}

Promise object to set the result into.

D++ Library version 9.0.13 D++ Library version 9.0.12 D++ Library version 9.0.11 D++ Library version 9.0.10 D++ Library version 9.0.9 D++ Library version 9.0.8 D++ Library version 9.0.7 D++ Library version 9.0.6 D++ Library version 9.0.5 D++ Library version 9.0.4 D++ Library version 9.0.3 D++ Library version 9.0.2 D++ Library version 9.0.1 D++ Library version 9.0.0 D++ Library version 1.0.2 D++ Library version 1.0.1 D++ Library version 1.0.0